package Bandiere;

import java.awt.Color;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Scanner;

import javax.swing.JPanel;

public class DownloaderThread implements Runnable {

	private ClientFrame frame;
	private ClientListener listener;
	private Scanner scanner;
	private Hashtable<Integer, Color> colors;
	private Hashtable<String, JPanel> panels;
	
	private boolean running;
	private boolean errored;
	
	public DownloaderThread(ClientFrame frame, ClientListener listener, Scanner scanner) {
		this.frame = frame;
		this.listener = listener;
		this.scanner = scanner;
		this.colors = new Hashtable<Integer, Color>();
		this.panels = new Hashtable<String, JPanel>();
		this.colors.put(0, Color.WHITE);
		this.colors.put(1, Color.BLACK);
		this.colors.put(2, Color.GREEN);
		this.colors.put(3, Color.RED);
		this.colors.put(4, Color.YELLOW);
		this.colors.put(5, Color.BLUE);
		this.colors.put(6, Color.ORANGE);
		this.panels.put("SX", frame.center.panel1);
		this.panels.put("CX", frame.center.panel2);
		this.panels.put("DX", frame.center.panel3);
	}

	@Override
	public void run() {
		if (running) {
			return;
		}
		
		running = true;
		
		while (running) {
			// Check if the current thread has been interrupted
			if (Thread.currentThread().isInterrupted()) {
				running = false;
				return;
			}
			
			// Process server data
			String cmd = scanner.nextLine();
			System.out.println("Ricevuto" + cmd);
			
			// End sequence
			if (cmd.equalsIgnoreCase("END")) {
				running = false;
				listener.downloadComplete();
				if (errored) {
					listener.disconnected();
				}
			}
			
			// Error sequence
			else if (cmd.equalsIgnoreCase("ERROR")) {
				running = false;
				errored = true;
				listener.disconnected();
			}
			
			// Interrupt sequence
			else if (cmd.equalsIgnoreCase("INTERRUPTED")) {
				running = false;
			}
			
			// SPECIFIC SOLUTION FOR FLAGS EXERCISE
			else {
				String[] parts = cmd.split(";");
				if (parts[0].equals("-1") && parts[1].equals("-1")) {
					running = false;
					listener.downloadComplete();
					if (errored) {
						listener.disconnected();
					}
				} else {
					Color color = colors.get(Integer.parseInt(parts[0]));
					JPanel panel = panels.get(parts[1]);
					panel.setBackground(color);
				}
			}

		 }
		}
	
	public void stop() {
		if (!running) {
			return;
		} else {
			running = false;
		}
	}
}

